=== debian/changelog ===
libiio (0.19-1) unstable; urgency=medium

  * New upstream release
  * update to v0.19-15-g490c4aa

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 18 Feb 2020 20:18:41 -0500
